module TRA_LIGHT(CLK,LED,SEG,SEL);

input CLK;

output[7:0] LED;
output[7:0] SEG,SEL;

reg[7:0] LED;
reg[7:0] SEG,SEL;

reg[23:0] CNT;
reg[3:0] DIS_BUFF;
reg SEC;
reg[2:0] STATUS;
reg[7:0] TIME;

parameter 		
					YELLOE_1=0,
					GREEN=1,
					RED=2,
					YELLOE_2=3;
		
always @ (posedge CLK) 
  begin
  CNT=CNT+1;
	if (CNT==24'd12000000) 
	begin CNT=0;SEC=~SEC;end //0.5뵽
  end

always @ (posedge SEC)
  begin 
	case (STATUS)
	   YELLOE_1:
		  if((TIME[7:4]==0)&&(TIME[3:0]==0))
			begin
			 STATUS<=GREEN;
			 TIME[7:4]<=2;TIME[3:0]<=5;
			 LED<=8'b01111110;
			end 
		  else
			begin
			 TIME[3:0]<=TIME[3:0]-1;
			 if(TIME[3:0]==0)begin TIME[3:0]<=9;TIME[7:4]<=TIME[7:4]-1;end
			end		
	
		GREEN:
		  if((TIME[7:4]==0)&&(TIME[3:0]==0))
			begin
			 STATUS<=YELLOE_2;
			 TIME[7:4]<=0;TIME[3:0]<=5;
			 LED<=8'b10111101;
			end 
		  else
			begin
			 TIME[3:0]<=TIME[3:0]-1;
			 if(TIME[3:0]==0)begin TIME[3:0]<=9;TIME[7:4]<=TIME[7:4]-1;end
			end
 
		YELLOE_2:
		  if((TIME[7:4]==0)&&(TIME[3:0]==0))
			begin
			 STATUS<=RED;
			 TIME[7:4]<=1;TIME[3:0]<=0;
			 LED<=8'b11011011;
			end 
		  else
			begin
			 TIME[3:0]<=TIME[3:0]-1;
			 if(TIME[3:0]==0)begin TIME[3:0]<=9;TIME[7:4]<=TIME[7:4]-1;end
			end
			
		RED:
		  if((TIME[7:4]==0)&&(TIME[3:0]==0))
			begin
			 STATUS<=YELLOE_1;
			 TIME[7:4]<=0;TIME[3:0]<=5;
			 LED<=8'b10111101;
			end 
		  else
			begin
			 TIME[3:0]<=TIME[3:0]-1;
			 if(TIME[3:0]==0)begin TIME[3:0]<=9;TIME[7:4]<=TIME[7:4]-1;end
			end	
	endcase
  end
  
always @ (CNT[13:12])
 begin
  case (CNT[13:12])
	2'b00:DIS_BUFF=TIME[3:0];
	2'b01:DIS_BUFF=TIME[7:4];
	2'b10:DIS_BUFF=TIME[3:0];	
	2'b11:DIS_BUFF=TIME[7:4];
	endcase
 end

always @ (CNT[13:12])
 begin
  case (CNT[13:12])
	2'b00:SEL=8'b00000001;
	2'b01:SEL=8'b00000010;
	2'b10:SEL=8'b01000000;
	2'b11:SEL=8'b10000000;
	endcase
 end

always @ (DIS_BUFF)
 begin
  case (DIS_BUFF)
	4'd0:SEG<=8'h3f;	//ͳ0ֶ
   4'd1:SEG<=8'h06;	//ͳ1ֶ
   4'd2:SEG<=8'h5b;	//ͳ2ֶ
   4'd3:SEG<=8'h4f;	//ͳ3ֶ?   
	4'd4:SEG<=8'h66;	//ͳ4ֶ
   4'd5:SEG<=8'h6d;	//ͳ5ֶ
   4'd6:SEG<=8'h7d;	//ͳ6ֶ
   4'd7:SEG<=8'h07;  //ͳ7ֶ
   4'd8:SEG<=8'h7f;  //ͳ8ֶ
   4'd9:SEG<=8'h6f;  //ͳ9ֶ
	endcase
 end 
  
endmodule
