module CPLD_MCU_RW(DATA_PORT,RD,WR,ALE,KEY,LED);
inout[7:0] DATA_PORT;		//˿ڣ8λߣ
input RD;						//˿ڣ壩
input WR;					//˿ڣд壩
input ALE;					//˿ڣַ壩
input[7:0] KEY;				//˿ڣˣ
output[7:0] LED;				//˿ڣˣ
//-----------------------------------
reg[7:0] CONTROL_REG;		//CONTROL _REGΪĴ͵8λ
reg[7:0] KEY_REG;			//KEY_REGΪĴ͵8λ
reg[7:0] LED_REG;			//LED_REGΪĴ͵8λ
//-----------------------------------
always@(negedge ALE)			//ÿALE½ʱ
begin
CONTROL_REG= DATA_PORT;	//ϵCONTROL _REGĴ
end
//-----------------------------------
always@(negedge RD)			//ÿRD½ʱ
begin
  if(CONTROL_REG==8'b00000000) //CONTROL _REGĴΪ00000000
KEY_REG=KEY;	//ȡص״̬
else 							//
KEY_REG=8'bzzzzzzzz;    // KEY_REGĴø
end
//-----------------------------------
always@(negedge WR)			//ÿWR½ʱ
begin
if(CONTROL_REG==8'b00000001) //CONTROL _REGĴΪ00000001
LED_REG= DATA_PORT;  	//ȡߵݲ
end
//-----------------------------------
assign DATA_PORT =RD? 8'bzzzzzzzz:KEY_REG; //ֵ
assign LED=LED_REG;			//ֵ
//-----------------------------------
endmodule
